<?php

namespace App\Services\Customer;

use App\Entities\Customer\PaymentEntity;
use App\Helpers\Customer\PaymentHelper;
use App\Models\Customer\PaymentModel;

class PaymentService extends CustomerService
{
    public function __construct()
    {
        parent::__construct(new PaymentModel(), new PaymentHelper());
        $this->addClassName('Payment');
    }
    public function getModelClass(): PaymentModel
    {
        return new PaymentModel();
    }
    public function getEntityClass(): PaymentEntity
    {
        return new PaymentEntity();
    }
    public function getFormFields(): array
    {
        return [
            "clientinfo_uid",
            "serviceinfo_uid",
            "title",
            "amount",
            "billing",
            "billing_at",
            "pay",
            "status",
        ];
    }
    public function getFormFilters(): array
    {
        return  [
            'clientinfo_uid',
            'billing',
            'pay',
            'status',
            'user_uid',
        ];
    }
    public function getIndexFields(): array
    {
        return [
            'clientinfo_uid',
            'billing',
            'title',
            'amount',
            'billing_at',
            'pay',
            'status',
            'updated_at',
            'countdown',
            'user_uid',
        ];
    }
    public function getBatchjobFields(): array
    {
        return ['clientinfo_uid', 'billing', 'pay', 'status'];
    }
    public function getBatchjobButtons(): array
    {
        return [
            'invoice' => '청구서 발행',
        ];
    }
    //기본 기능부분
    //FieldForm관련용
    public function getFormOption(string $field, array $options = []): array
    {
        switch ($field) {
            case 'user_uid':
                $options = $this->getUserService()->getEntities();
                break;
            case 'clientinfo_uid':
                $options = $this->getClientService()->getEntities();
                break;
            case 'serviceinfo_uid':
                $options = $this->getServiceService()->getEntities();
                break;
            default:
                $options = parent::getFormOption($field, $options);
                break;
        }
        return $options;
    }
    //List 검색용
    //OrderBy 처리
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->getModel()->orderBy('billing_at ASC');
        parent::setOrderBy($field, $value);
    }
    //총 미납건수, 금액
    public function getUnPaids(string $group, array $where = []): array
    {
        $rows = $this->getModel()->groupBy($group)
            ->select("COUNT(uid) as cnt, SUM(amount) as amount")
            ->where(['billing_at <=' => date('Y-m-d')])
            ->where(['status' => STATUS['UNPAID']])
            ->where($where)
            ->get()->getResult();
        return $rows;
    }
}
